version: "{branch} (#{build})"

image:
  - Visual Studio 2015
  - Visual Studio 2017
  - Visual Studio 2019

environment:
  DEBUG: 1
  WARNINGS: 1
  matrix:
    - STANDALONE: 1
      HEADER_ONLY: 1
      MSVC: 1
    - STANDALONE: 1
      SEPARATE_COMPILATION: 1
      MSVC: 1
    - STANDALONE: 1
      MINGW: 1
    - STANDALONE: 1
      CXXLATEST: 1
      MSVC: 1
    - STANDALONE: 1
      HEADER_ONLY: 1
      WIN9X: 1
      MSVC: 1
    - STANDALONE: 1
      SEPARATE_COMPILATION: 1
      WIN9X: 1
      MSVC: 1
    - USING_BOOST: 1
      HEADER_ONLY: 1
      MSVC: 1
    - USING_BOOST: 1
      SEPARATE_COMPILATION: 1
      MSVC: 1
    - USING_BOOST: 1
      MINGW: 1

for:
  -
    matrix:
      only:
        - image: Visual Studio 2015
          MSVC: 1
    environment:
      BOOSTDIR: C:\Libraries\boost_1_67_0
    build_script:
      - call "C:\Program Files\Microsoft SDKs\Windows\v7.1\Bin\SetEnv.cmd" /x64
      - call "C:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" x86_amd64
      - cd src
      - nmake -f Makefile.msc
      - nmake -f Makefile.msc check
  -
    matrix:
      only:
        - image: Visual Studio 2017
          MSVC: 1
    environment:
      BOOSTDIR: C:\Libraries\boost_1_69_0
      _WIN32_WINNT: 0x0603
    build_script:
      - call "C:\Program Files (x86)\Microsoft Visual Studio\2017\Community\VC\Auxiliary\Build\vcvarsall.bat" x86_amd64
      - cd src
      - nmake -f Makefile.msc
      - nmake -f Makefile.msc check
  -
    matrix:
      only:
        - image: Visual Studio 2019
          MSVC: 1
    environment:
      BOOSTDIR: C:\Libraries\boost_1_89_0
      _WIN32_WINNT: 0x0A00
    build_script:
      - call "C:\Program Files (x86)\Microsoft Visual Studio\2019\Community\VC\Auxiliary\Build\vcvarsall.bat" x86_amd64
      - cd src
      - nmake -f Makefile.msc
      - nmake -f Makefile.msc check
  -
    matrix:
      only:
        - image: Visual Studio 2019
          MINGW: 1
    environment:
      BOOSTDIR: C:/Libraries/boost_1_89_0
    build_script:
      - PATH=C:\mingw-w64\x86_64-8.1.0-posix-seh-rt_v6-rev0\mingw64\bin;C:\msys64\usr\bin;%PATH%
      - cd src
      - mingw32-make -f Makefile.mgw
      - mingw32-make -f Makefile.mgw check

matrix:
  exclude:
    - image: Visual Studio 2015
      HEADER_ONLY: 1
    - image: Visual Studio 2015
      CXXLATEST: 1
    - image: Visual Studio 2015
      WIN9X: 1
    - image: Visual Studio 2015
      USING_BOOST: 1
    - image: Visual Studio 2015
      MINGW: 1
    - image: Visual Studio 2017
      SEPARATE_COMPILATION: 1
    - image: Visual Studio 2017
      CXXLATEST: 1
    - image: Visual Studio 2017
      WIN9X: 1
    - image: Visual Studio 2017
      USING_BOOST: 1
    - image: Visual Studio 2017
      MINGW: 1
    - image: Visual Studio 2019
      HEADER_ONLY: 1
    - image: Visual Studio 2019
      WIN9X: 1
